
.386
CODE32 SEGMENT PUBLIC PARA 'CODE' USE32
ASSUME  CS:CODE32,DS:CODE32,ES:CODE32,FS:CODE32,GS:CODE32,SS:CODE32

Include   DOS32.INC
Include   MOUSE.INC
Include   Macros.386

Mouse_Init PROC


;    Initalise the mouse and UART    


        mov     edx,offset Mouse_Interrupt_Handler
        mov     bl,4
        mov     cx,cs
        call    SetIRQvector


        outp    3FCh,00000000b                   ; Modem Control Register


 ; Clear the FIFOs and set to 14 bytes.

        outp    3FAh,11000111b                   ; FIFO Control Register


 ; Set Baud rate to 1200

        outp    3FBh,10000000b                   ; Line Control Register

        outp    3F8h,60h                         ; Baud Rate Diviser LSB
        outp    3F9h,00h                         ; Baud Rate Diviser MSB


; Set Word length 7bits, 1 stop bit, no paratiy, ect
        outp    3FBh,00000010b                   ; Line Control Register


        outp    3F9h,00000001b                   ; Interrupt Enable Register


; Set DTR high to initalize the mouse. The mouse will then respond with
; the character 'M'.

        outp    3FCh,00000001b                   ; Modem Control Register



        clc
        ret
error:
        stc
        ret
Mouse_Init ENDP



; IRQ 3,4 
;			 MOUSE INERRUPT HANDLER
;

;- DATA  VARIBLES USED FOR MOUSE HANDLER -
align 4
Mouse_X			dd 0
Mouse_Y			dd 0
Mouse_UART_Base		dw 3F8h
Mouse_DataCount		db 0
MouseData               db 3 DUP (?)
mouse_testing           db True


Mouse_Interrupt_Handler PROC

   push eax
   push edx
   push ds
   mov  ds,cs:data32_sel
   mov DX,[Mouse_Uart_Base]	;Get The data byte from UART
   in AL,DX                     ; Transmit/Recieve Buffer.
   cmp   mouse_testing,True
   je Test_it
Tested_it:
   test al,40h			; see if data is first mouse byte
   jz Mncom3
   mov Mouse_DataCount,0	;Mouse is outputing a new position
Mncom3:
   movzx EDX,Mouse_DataCount
   mov MouseData[EDX],AL         ; Save the specific byte (1,2 or 3)
   inc Mouse_DataCount
   cmp Mouse_DataCount,3	; Must get all 3 mouse data bytes
   jnz all3Commands		; Exit if < 3 bytes have been read


            ;--- can now uptade [Mouse_X] and [Mouse_Y] positions  ----
              mov al,MouseData+0	; get first mouse data byte
                mov dl,al
		and dL,00000011b        ;put bits 0..1 to 6..7 on Mouse_X
                shl dl,6
                add dl,MouseData+1	; get second mouse data byte
                movsx edx,dl
                add Mouse_X,edx

                mov dl,al
		and dl,00001100b
                shl dl,4
                add dl,MouseData+2	; get third mouse data byte
                movsx edx,dl
                add Mouse_Y,edx
                ;---------- Mouse coordinates uptaded ---------


All3Commands:


   mov dx,[Mouse_Uart_Base]	; Set the Interrupt Enable Register on UART
   add dx,1
   mov al,1        		; Enable data varible interrupt ( bit 0 )
   out dx,al
   mov al,20h
   out 20h,al
   pop  ds
   pop edx
   pop eax
   iretd

Test_it:
        cmp     al,'M'
        jne All3Commands
        mov     mouse_testing,False
        jmp All3Commands

;			MOUSE HANDLER ENDS
;

Mouse_Interrupt_Handler ENDP

CODE32 ENDS
END
